function dq = right_part(t,q)
% this funciton implement the variables and first derivatives of Eq.(5)
% the coupled second derivatives are implemented by mass matrix
global Theta_0 theta_0 alpha theta_st l number mass k_theta
global Tinput dispU

%% Input signal
% interpolate the input signal
if t<Tinput(end)
    Disp = interp1(Tinput,dispU,t);
    DDisp= interp1(Tinput(1:end-1),diff(dispU)./diff(Tinput),t);
else
    Disp = dispU(end);
    DDisp= 0;
end

%% boundary conditions
dq=zeros(2*number,1); % assign zeros to derivatives
% left end: apply interpolated input signal
i=1;
posi=2*(i-1);
q(posi+1) = Disp;
q(posi+2) = DDisp;
dq(posi+1) = q(posi+2);
% right end: apply fixed boundary condition
i = number;
posi=2*(i-1);
q(posi+1) = 0;
q(posi+2) = 0;
%% Implement of Eq.(5)
for i=2:number-1 
    % define q and q's neigbours and their derivatives
    posi=2*(i-1);
    q_this = q(posi+1);
    dq_this = q(posi+2);
    q_m = q(posi-1);
    dq_m = q(posi);
    q_p = q(posi+3);
    dq_p = q(posi+4);
    
    % define other terms in terms of q and q's neigbours and their derivatives
    alpha_this = (q_this - q_m)/2/l+cos(Theta_0);
    alpha_p = (q_p - q_this)/2/l+cos(Theta_0);
    dalpha_this = (dq_this-dq_m)/2/l;
    dalpha_p = (dq_p-dq_this)/2/l;
    
    theta_this = acos((q_this - q_m)/2/l + cos(Theta_0)) - Theta_0;
    theta_p = acos((q_p - q_this)/2/l + cos(Theta_0)) - Theta_0;
    dtheta_this = -1/(2*l*(1-alpha_this^2)^0.5);
    dtheta_p = 1/(2*l*(1-alpha_p^2)^0.5);
    
    theta_st = Theta_0 - theta_0;
    
    % write the variables and first derivatives of Eq.(5)
    % the second derivative parts are implemented in mass matrix
    dq(posi+1) = q(posi+2);
    force = (alpha)/2*mass*(1)*(((dq_this-dq_m)^2-(dq_p - dq_this)^2)/4*cos(Theta_0)/l/sin(Theta_0)^4)...
        - 4*(2)*k_theta*(theta_this*dtheta_this+theta_p*dtheta_p)-4*(2)*k_theta*theta_st*(dtheta_this+dtheta_p)...
        - (alpha)/2*mass*(((dq_this-dq_m)*alpha_this*dalpha_this)/(1-alpha_this^2)^2) ...
        + (alpha)/2*mass*(((dq_p-dq_this)*alpha_p*dalpha_p)/(1-alpha_p^2)^2);
    dq(posi+2) = force/mass;
end